/** @file um-netdania-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UM_NETDANIA_CLO_H
#define UM_NETDANIA_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef ND_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define ND_PARSER_PACKAGE "netdania"
#endif

#ifndef ND_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define ND_PARSER_PACKAGE_NAME "netdania"
#endif

#ifndef ND_PARSER_VERSION
/** @brief the program version */
#define ND_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct nd_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *raw_help; /**< @brief Display uninterpreted feed help description.  */
  int beef_arg;	/**< @brief Multicast payload channels, default 7868.  */
  char * beef_orig;	/**< @brief Multicast payload channels, default 7868 original value given at command line.  */
  const char *beef_help; /**< @brief Multicast payload channels, default 7868 help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int raw_given ;	/**< @brief Whether raw was given.  */
  unsigned int beef_given ;	/**< @brief Whether beef was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct nd_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure nd_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure nd_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *nd_args_info_purpose;
/** @brief the usage string of the program */
extern const char *nd_args_info_usage;
/** @brief the description string of the program */
extern const char *nd_args_info_description;
/** @brief all the lines making the help output */
extern const char *nd_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int nd_parser (int argc, char **argv,
  struct nd_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use nd_parser_ext() instead
 */
int nd_parser2 (int argc, char **argv,
  struct nd_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int nd_parser_ext (int argc, char **argv,
  struct nd_args_info *args_info,
  struct nd_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int nd_parser_dump(FILE *outfile,
  struct nd_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int nd_parser_file_save(const char *filename,
  struct nd_args_info *args_info);

/**
 * Print the help
 */
void nd_parser_print_help(void);
/**
 * Print the version
 */
void nd_parser_print_version(void);

/**
 * Initializes all the fields a nd_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void nd_parser_params_init(struct nd_parser_params *params);

/**
 * Allocates dynamically a nd_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized nd_parser_params structure
 */
struct nd_parser_params *nd_parser_params_create(void);

/**
 * Initializes the passed nd_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void nd_parser_init (struct nd_args_info *args_info);
/**
 * Deallocates the string fields of the nd_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void nd_parser_free (struct nd_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int nd_parser_required (struct nd_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UM_NETDANIA_CLO_H */
