/** @file um-quodmp-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UM_QUODMP_CLO_H
#define UM_QUODMP_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef UMQD_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define UMQD_PARSER_PACKAGE "um-quodmp"
#endif

#ifndef UMQD_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define UMQD_PARSER_PACKAGE_NAME "um-quodmp"
#endif

#ifndef UMQD_PARSER_VERSION
/** @brief the program version */
#define UMQD_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct umqd_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *daemonise_help; /**< @brief Detach from tty and runs as daemon help description.  */
  char * output_arg;	/**< @brief Write result to specified output file.  */
  char * output_orig;	/**< @brief Write result to specified output file original value given at command line.  */
  const char *output_help; /**< @brief Write result to specified output file help description.  */
  char * into_arg;	/**< @brief Write result into ute file FILE.  */
  char * into_orig;	/**< @brief Write result into ute file FILE original value given at command line.  */
  const char *into_help; /**< @brief Write result into ute file FILE help description.  */
  int port_arg;	/**< @brief Multicast control channel port (default='8653').  */
  char * port_orig;	/**< @brief Multicast control channel port original value given at command line.  */
  const char *port_help; /**< @brief Multicast control channel port help description.  */
  int* beef_arg;	/**< @brief Multicast payload channels, can be used multiple times.  */
  char ** beef_orig;	/**< @brief Multicast payload channels, can be used multiple times original value given at command line.  */
  unsigned int beef_min; /**< @brief Multicast payload channels, can be used multiple times's minimum occurreces */
  unsigned int beef_max; /**< @brief Multicast payload channels, can be used multiple times's maximum occurreces */
  const char *beef_help; /**< @brief Multicast payload channels, can be used multiple times help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int daemonise_given ;	/**< @brief Whether daemonise was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int into_given ;	/**< @brief Whether into was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int beef_given ;	/**< @brief Whether beef was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct umqd_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure umqd_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure umqd_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *umqd_args_info_purpose;
/** @brief the usage string of the program */
extern const char *umqd_args_info_usage;
/** @brief the description string of the program */
extern const char *umqd_args_info_description;
/** @brief all the lines making the help output */
extern const char *umqd_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqd_parser (int argc, char **argv,
  struct umqd_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use umqd_parser_ext() instead
 */
int umqd_parser2 (int argc, char **argv,
  struct umqd_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqd_parser_ext (int argc, char **argv,
  struct umqd_args_info *args_info,
  struct umqd_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqd_parser_dump(FILE *outfile,
  struct umqd_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqd_parser_file_save(const char *filename,
  struct umqd_args_info *args_info);

/**
 * Print the help
 */
void umqd_parser_print_help(void);
/**
 * Print the version
 */
void umqd_parser_print_version(void);

/**
 * Initializes all the fields a umqd_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void umqd_parser_params_init(struct umqd_parser_params *params);

/**
 * Allocates dynamically a umqd_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized umqd_parser_params structure
 */
struct umqd_parser_params *umqd_parser_params_create(void);

/**
 * Initializes the passed umqd_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void umqd_parser_init (struct umqd_args_info *args_info);
/**
 * Deallocates the string fields of the umqd_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void umqd_parser_free (struct umqd_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int umqd_parser_required (struct umqd_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UM_QUODMP_CLO_H */
