/** @file um-quomon-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UM_QUOMON_CLO_H
#define UM_QUOMON_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef UMQM_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define UMQM_PARSER_PACKAGE "um-quomon"
#endif

#ifndef UMQM_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define UMQM_PARSER_PACKAGE_NAME "um-quomon"
#endif

#ifndef UMQM_PARSER_VERSION
/** @brief the program version */
#define UMQM_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct umqm_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int fps_arg;	/**< @brief Rerender the screen NUM times a second. (default='10').  */
  char * fps_orig;	/**< @brief Rerender the screen NUM times a second. original value given at command line.  */
  const char *fps_help; /**< @brief Rerender the screen NUM times a second. help description.  */
  int port_arg;	/**< @brief Multicast control channel port (default='8653').  */
  char * port_orig;	/**< @brief Multicast control channel port original value given at command line.  */
  const char *port_help; /**< @brief Multicast control channel port help description.  */
  int* beef_arg;	/**< @brief Multicast payload channels, can be used multiple times.  */
  char ** beef_orig;	/**< @brief Multicast payload channels, can be used multiple times original value given at command line.  */
  unsigned int beef_min; /**< @brief Multicast payload channels, can be used multiple times's minimum occurreces */
  unsigned int beef_max; /**< @brief Multicast payload channels, can be used multiple times's maximum occurreces */
  const char *beef_help; /**< @brief Multicast payload channels, can be used multiple times help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int fps_given ;	/**< @brief Whether fps was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int beef_given ;	/**< @brief Whether beef was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct umqm_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure umqm_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure umqm_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *umqm_args_info_purpose;
/** @brief the usage string of the program */
extern const char *umqm_args_info_usage;
/** @brief the description string of the program */
extern const char *umqm_args_info_description;
/** @brief all the lines making the help output */
extern const char *umqm_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqm_parser (int argc, char **argv,
  struct umqm_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use umqm_parser_ext() instead
 */
int umqm_parser2 (int argc, char **argv,
  struct umqm_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqm_parser_ext (int argc, char **argv,
  struct umqm_args_info *args_info,
  struct umqm_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqm_parser_dump(FILE *outfile,
  struct umqm_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int umqm_parser_file_save(const char *filename,
  struct umqm_args_info *args_info);

/**
 * Print the help
 */
void umqm_parser_print_help(void);
/**
 * Print the version
 */
void umqm_parser_print_version(void);

/**
 * Initializes all the fields a umqm_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void umqm_parser_params_init(struct umqm_parser_params *params);

/**
 * Allocates dynamically a umqm_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized umqm_parser_params structure
 */
struct umqm_parser_params *umqm_parser_params_create(void);

/**
 * Initializes the passed umqm_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void umqm_parser_init (struct umqm_args_info *args_info);
/**
 * Deallocates the string fields of the umqm_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void umqm_parser_free (struct umqm_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int umqm_parser_required (struct umqm_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UM_QUOMON_CLO_H */
